GET /api/openapi.json; no token is needed to read it. Customer data and deployment operations still require authentication. The interactive reference is in the app.
Authenticated operations accept Authorization: Bearer $SPRINGWINTER_TOKEN. Cookie mutations require a CSRF token. Signed webhooks use their own signature checks. Read each operation’s security setting.
GET /api/csrf
Issue a CSRF token
{
"tags": [
"Session"
],
"summary": "Issue a CSRF token",
"operationId": "getCsrf",
"security": [],
"responses": {
"200": {
"description": "Token for `X-CSRF-Token` on mutating requests",
"content": {
"application/json": {
"schema": {
"type": "object",
"required": [
"csrf_token"
],
"properties": {
"csrf_token": {
"type": "string"
}
}
}
}
}
}
},
"parameters": []
}
POST /api/password
POST /api/password
{
"tags": [
"Account"
],
"summary": "POST /api/password",
"operationId": "postApiPassword",
"responses": {
"202": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"pending_reset": {
"const": true
}
},
"required": [
"pending_reset"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; verification_email_failed",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"verification_email_failed"
]
}
},
"required": [
"error"
]
}
}
}
},
"429": {
"description": "rate_limited",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"rate_limited"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"security": [],
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"email_address": {
"type": "string"
}
},
"required": [
"email_address"
]
}
}
}
},
"parameters": []
}
POST /api/password/confirmation
POST /api/password/confirmation
{
"tags": [
"Account"
],
"summary": "POST /api/password/confirmation",
"operationId": "postApiPasswordConfirmation",
"responses": {
"201": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"$ref": "#/components/schemas/AccountProfile"
},
"csrf_token": {
"type": "string"
}
},
"required": [
"user",
"csrf_token"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; invalid_code; invalid_password",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"invalid_code",
"invalid_password"
]
}
},
"required": [
"error"
]
}
}
}
},
"429": {
"description": "rate_limited",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"rate_limited"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"security": [],
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"email_address": {
"type": "string"
},
"code": {
"type": "string"
},
"password": {
"type": "string",
"minLength": 8,
"maxLength": 72,
"format": "password"
},
"password_confirmation": {
"type": "string"
}
},
"required": [
"email_address",
"code",
"password",
"password_confirmation"
]
}
}
}
},
"parameters": []
}
POST /api/registration
POST /api/registration
{
"tags": [
"Account"
],
"summary": "POST /api/registration",
"operationId": "postApiRegistration",
"responses": {
"202": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"pending_verification": {
"const": true
}
},
"required": [
"pending_verification"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; email_taken; invalid_registration; verification_email_failed",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"email_taken",
"invalid_registration",
"verification_email_failed"
]
}
},
"required": [
"error"
]
}
}
}
},
"429": {
"description": "rate_limited",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"rate_limited"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"security": [],
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"registration": {
"type": "object",
"properties": {
"email_address": {
"type": "string",
"format": "email"
},
"password": {
"type": "string",
"minLength": 8,
"maxLength": 72,
"format": "password"
},
"organization_name": {
"type": "string"
}
},
"required": [
"email_address",
"password",
"organization_name"
]
}
},
"required": [
"registration"
]
}
}
}
},
"parameters": []
}
POST /api/registration/confirmation
POST /api/registration/confirmation
{
"tags": [
"Account"
],
"summary": "POST /api/registration/confirmation",
"operationId": "postApiRegistrationConfirmation",
"responses": {
"201": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"$ref": "#/components/schemas/AccountProfile"
},
"csrf_token": {
"type": "string"
}
},
"required": [
"user",
"csrf_token"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; invalid_code",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"invalid_code"
]
}
},
"required": [
"error"
]
}
}
}
},
"429": {
"description": "rate_limited",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"rate_limited"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"security": [],
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"email_address": {
"type": "string"
},
"code": {
"type": "string"
}
},
"required": [
"email_address",
"code"
]
}
}
}
},
"parameters": []
}
POST /api/registration/resend
POST /api/registration/resend
{
"tags": [
"Account"
],
"summary": "POST /api/registration/resend",
"operationId": "postApiRegistrationResend",
"responses": {
"202": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"pending_verification": {
"const": true
}
},
"required": [
"pending_verification"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; verification_email_failed",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"verification_email_failed"
]
}
},
"required": [
"error"
]
}
}
}
},
"429": {
"description": "rate_limited",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"rate_limited"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"security": [],
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"email_address": {
"type": "string"
}
},
"required": [
"email_address"
]
}
}
}
},
"parameters": []
}
GET /api/session
Current user
{
"tags": [
"Session"
],
"summary": "Current user",
"operationId": "getSession",
"responses": {
"200": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"$ref": "#/components/schemas/AccountProfile"
}
},
"required": [
"user"
]
}
}
}
},
"401": {
"description": "unauthenticated",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"unauthenticated"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"parameters": []
}
POST /api/session
Sign in
{
"tags": [
"Session"
],
"summary": "Sign in",
"operationId": "createSession",
"security": [],
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"required": [
"session"
],
"properties": {
"session": {
"type": "object",
"required": [
"email_address",
"password"
],
"properties": {
"email_address": {
"type": "string",
"format": "email"
},
"password": {
"type": "string",
"format": "password"
}
}
}
}
}
}
}
},
"responses": {
"201": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"$ref": "#/components/schemas/AccountProfile"
},
"csrf_token": {
"type": "string"
}
},
"required": [
"user",
"csrf_token"
]
}
}
}
},
"400": {
"$ref": "#/components/responses/InvalidParameters"
},
"401": {
"description": "invalid_credentials",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_credentials"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token"
]
}
},
"required": [
"error"
]
}
}
}
},
"429": {
"description": "rate_limited",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"rate_limited"
]
}
},
"required": [
"error"
]
}
}
}
},
"403": {
"description": "email_unverified",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"email_unverified"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"parameters": []
}
DELETE /api/session
Sign out
{
"tags": [
"Session"
],
"summary": "Sign out",
"operationId": "destroySession",
"responses": {
"204": {
"description": "Session cookie cleared"
},
"401": {
"$ref": "#/components/responses/Unauthenticated"
},
"422": {
"$ref": "#/components/responses/InvalidCsrf"
}
},
"parameters": []
}
PATCH /api/user
PATCH /api/user
{
"tags": [
"Account"
],
"summary": "PATCH /api/user",
"operationId": "patchApiUser",
"responses": {
"200": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"$ref": "#/components/schemas/AccountProfile"
}
},
"required": [
"user"
]
}
}
}
},
"401": {
"description": "unauthenticated",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"unauthenticated"
]
}
},
"required": [
"error"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; password_unavailable; invalid_user",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"password_unavailable",
"invalid_user"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"type": "object",
"properties": {
"name": {
"type": [
"string",
"null"
],
"maxLength": 80
},
"password": {
"type": "string",
"minLength": 8,
"maxLength": 72,
"format": "password"
},
"password_confirmation": {
"type": "string"
}
},
"required": []
}
},
"required": [
"user"
]
}
}
}
},
"parameters": []
}
PUT /api/user
PATCH /api/user
{
"tags": [
"Account"
],
"summary": "PATCH /api/user",
"operationId": "putApiUser",
"responses": {
"200": {
"description": "Successful response",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"$ref": "#/components/schemas/AccountProfile"
}
},
"required": [
"user"
]
}
}
}
},
"401": {
"description": "unauthenticated",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"unauthenticated"
]
}
},
"required": [
"error"
]
}
}
}
},
"400": {
"description": "invalid_parameters",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_parameters"
]
}
},
"required": [
"error"
]
}
}
}
},
"422": {
"description": "invalid_csrf_token; password_unavailable; invalid_user",
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"error": {
"type": "string",
"enum": [
"invalid_csrf_token",
"password_unavailable",
"invalid_user"
]
}
},
"required": [
"error"
]
}
}
}
}
},
"requestBody": {
"required": true,
"content": {
"application/json": {
"schema": {
"type": "object",
"properties": {
"user": {
"type": "object",
"properties": {
"name": {
"type": [
"string",
"null"
],
"maxLength": 80
},
"password": {
"type": "string",
"minLength": 8,
"maxLength": 72,
"format": "password"
},
"password_confirmation": {
"type": "string"
}
},
"required": []
}
},
"required": [
"user"
]
}
}
}
},
"parameters": []
}
Referenced definitions
These keys resolve the local references in the operations above.{
"#/components/responses/InvalidCsrf": {
"description": "Missing or stale CSRF token",
"content": {
"application/json": {
"schema": {
"$ref": "#/components/schemas/Error"
},
"example": {
"error": "invalid_csrf_token"
}
}
}
},
"#/components/responses/InvalidParameters": {
"description": "Missing or malformed JSON parameters",
"content": {
"application/json": {
"schema": {
"$ref": "#/components/schemas/Error"
},
"example": {
"error": "invalid_parameters"
}
}
}
},
"#/components/responses/Unauthenticated": {
"description": "No session cookie",
"content": {
"application/json": {
"schema": {
"$ref": "#/components/schemas/Error"
},
"example": {
"error": "unauthenticated"
}
}
}
},
"#/components/schemas/AccountProfile": {
"type": "object",
"properties": {
"id": {
"type": "string"
},
"email_address": {
"type": "string"
},
"name": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
},
"avatar_url": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
},
"sign_in_methods": {
"type": "array",
"items": {
"type": "string"
}
},
"organization": {
"type": "object",
"properties": {
"id": {
"type": "string"
},
"name": {
"type": "string"
},
"plan": {
"type": "string",
"enum": [
"free",
"pro",
"enterprise"
]
},
"members": {
"type": "array",
"items": {
"type": "object",
"properties": {
"id": {
"type": "string"
},
"name": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
},
"email_address": {
"type": "string"
},
"avatar_url": {
"anyOf": [
{
"type": "string"
},
{
"type": "null"
}
]
}
},
"required": [
"id",
"name",
"email_address",
"avatar_url"
]
}
}
},
"required": [
"id",
"name",
"plan",
"members"
]
}
},
"required": [
"id",
"email_address",
"name",
"avatar_url",
"sign_in_methods",
"organization"
]
},
"#/components/schemas/Error": {
"type": "object",
"required": [
"error"
],
"properties": {
"error": {
"type": "string"
},
"actions": {
"type": "array",
"items": {
"type": "string"
}
}
}
}
}